jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
| 20 | while [ -h "${prog}" ]; do |
| 21 | newProg=`/bin/ls -ld "${prog}"` |
| 22 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 23 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 24 | prog="${newProg}" |
| 25 | else |
| 26 | progdir=`dirname "${prog}"` |
| 27 | prog="${progdir}/${newProg}" |
| 28 | fi |
| 29 | done |
| 30 | oldwd=`pwd` |
| 31 | progdir=`dirname "${prog}"` |
| 32 | cd "${progdir}" |
| 33 | progdir=`pwd` |
| 34 | prog="${progdir}"/`basename "${prog}"` |
| 35 | |
| 36 | run_args="" |
| 37 | usage="no" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 38 | sequental="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 39 | |
| 40 | while true; do |
| 41 | if [ "x$1" = "x--host" ]; then |
| 42 | run_args="${run_args} --host" |
| 43 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 44 | elif [ "x$1" = "x--jvm" ]; then |
| 45 | run_args="${run_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 46 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 47 | elif [ "x$1" = "x--debug" ]; then |
| 48 | run_args="${run_args} --debug" |
| 49 | shift |
| 50 | elif [ "x$1" = "x--zygote" ]; then |
| 51 | run_args="${run_args} --zygote" |
| 52 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 53 | elif [ "x$1" = "x--interpreter" ]; then |
| 54 | run_args="${run_args} --interpreter" |
| 55 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 56 | elif [ "x$1" = "x--no-verify" ]; then |
| 57 | run_args="${run_args} --no-verify" |
| 58 | shift |
| 59 | elif [ "x$1" = "x--no-optimize" ]; then |
| 60 | run_args="${run_args} --no-optimize" |
| 61 | shift |
| 62 | elif [ "x$1" = "x--valgrind" ]; then |
| 63 | run_args="${run_args} --valgrind" |
| 64 | shift |
| 65 | elif [ "x$1" = "x--dev" ]; then |
| 66 | run_args="${run_args} --dev" |
| 67 | shift |
| 68 | elif [ "x$1" = "x--update" ]; then |
| 69 | run_args="${run_args} --update" |
| 70 | shift |
| 71 | elif [ "x$1" = "x--help" ]; then |
| 72 | usage="yes" |
| 73 | shift |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 74 | elif [ "x$1" = "x--seq" ]; then |
| 75 | sequental="yes" |
| 76 | shift |
| 77 | elif [ "x$1" = "x-O" ]; then |
| 78 | run_args="${run_args} -O" |
| 79 | shift |
Zheng Xu | dc8e732 | 2014-05-07 17:07:20 +0100 | [diff] [blame] | 80 | elif [ "x$1" = "x--64" ]; then |
| 81 | run_args="${run_args} --64" |
| 82 | shift |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 83 | elif [ "x$1" = "x--gcstress" ]; then |
| 84 | run_args="${run_args} --gcstress" |
| 85 | shift |
| 86 | elif [ "x$1" = "x--gcverify" ]; then |
| 87 | run_args="${run_args} --gcverify" |
| 88 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 89 | elif [ "x$1" = "x--trace" ]; then |
| 90 | run_args="${run_args} --trace" |
| 91 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 92 | elif [ "x$1" = "x--relocate" ]; then |
| 93 | run_args="${run_args} --relocate" |
| 94 | shift |
| 95 | elif [ "x$1" = "x--no-relocate" ]; then |
| 96 | run_args="${run_args} --no-relocate" |
| 97 | shift |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 98 | elif [ "x$1" = "x--no-prebuild" ]; then |
| 99 | run_args="${run_args} --no-prebuild" |
| 100 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 101 | elif [ "x$1" = "x--prebuild" ]; then |
| 102 | run_args="${run_args} --prebuild" |
| 103 | shift; |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 104 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 105 | run_args="${run_args} --no-dex2oat" |
| 106 | shift; |
| 107 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 108 | run_args="${run_args} --no-patchoat" |
| 109 | shift; |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 110 | elif [ "x$1" = "x--always-clean" ]; then |
| 111 | run_args="${run_args} --always-clean" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 112 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 113 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 114 | usage="yes" |
| 115 | break |
| 116 | else |
| 117 | break |
| 118 | fi |
| 119 | done |
| 120 | |
| 121 | if [ "$usage" = "yes" ]; then |
| 122 | prog=`basename $prog` |
| 123 | ( |
| 124 | echo "usage:" |
| 125 | echo " $prog --help Print this message." |
| 126 | echo " $prog [options] Run all tests with the given options." |
| 127 | echo " Options are all passed to run-test; refer to that for " \ |
| 128 | "further documentation:" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 129 | echo " --debug --dev --host --interpreter --jvm --no-optimize" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 130 | echo " --no-verify -O --update --valgrind --zygote --64 --relocate" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 131 | echo " --prebuild --always-clean --gcstress --gcverify --trace" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 132 | echo " --no-patchoat --no-dex2oat" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 133 | echo " Specific Runtime Options:" |
| 134 | echo " --seq Run tests one-by-one, avoiding failures caused by busy CPU" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 135 | ) 1>&2 |
| 136 | exit 1 |
| 137 | fi |
| 138 | |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 139 | if [ "$sequental" == "yes" ]; then |
| 140 | i=0 |
| 141 | for test_name in *; do |
| 142 | if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then |
| 143 | ./run-test ${run_args} "$test_name" |
| 144 | RES=$? |
| 145 | test_pids[i]=i |
| 146 | test_names[test_pids[i]]="$test_name" |
| 147 | if [ "$RES" != "0" ]; then |
| 148 | let failure_count+=1 |
| 149 | failed_test_names="$failed_test_names ${test_names[i]}" |
| 150 | else |
| 151 | let succeeded_count+=1 |
| 152 | fi |
| 153 | let i+=1 |
| 154 | fi |
| 155 | done |
| 156 | else |
| 157 | # start all the tests |
| 158 | i=0 |
| 159 | for test_name in *; do |
| 160 | if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then |
| 161 | ./run-test ${run_args} "$test_name" & |
| 162 | test_pids[i]=$! |
| 163 | test_names[test_pids[i]]="$test_name" |
| 164 | let i+=1 |
| 165 | fi |
| 166 | done |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 167 | |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 168 | # wait for all the tests, collecting the failures |
| 169 | failure_count=0 |
| 170 | succeeded_count=0 |
| 171 | failed_test_names="" |
| 172 | for pid in ${test_pids[@]}; do |
| 173 | wait $pid |
| 174 | if [ "$?" != "0" ]; then |
| 175 | let failure_count+=1 |
| 176 | failed_test_names="$failed_test_names ${test_names[$pid]}[pid=$pid]" |
| 177 | else |
| 178 | let succeeded_count+=1 |
| 179 | fi |
| 180 | done |
| 181 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 182 | |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 183 | echo "succeeded tests: $succeeded_count" |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 184 | echo "failed tests: $failure_count" |
| 185 | |
| 186 | for i in $failed_test_names; do |
| 187 | echo "failed: $i" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 188 | done |